<template>
  <b-container class="pidContainer">
    <!-- PID Information -->
    <CoscineHeadline :headline="$t('page.pid.title')" />

    <!-- PID Description -->
    <CoscineFormGroup>
      <b-form-text>{{ $t("page.pid.description") }}</b-form-text>
    </CoscineFormGroup>

    <!-- Persistent Identifier (PID) -->
    <CoscineFormGroup
      label-for="PID"
      :label="$t('page.pid.form.persistentIdLabel')"
      :info="true"
    >
      <template #popover>
        {{ $t("page.pid.form.persistentIdPopover") }}
        <b-link
          :href="$t('page.pid.form.persistentIdPopoverUrl').toString()"
          target="_blank"
        >
          {{ $t("default.help") }}
        </b-link>
      </template>

      <b-button-group class="w-100">
        <!-- Text Field -->
        <b-form-input
          id="PersistentId"
          v-model="pid"
          :readonly="true"
          :disabled="true"
          :state="isLoading ? null : isPidValid ? null : false"
        />
        <div class="invalid-tooltip">{{ $t("page.pid.noPid") }}</div>

        <!-- Copy Button -->
        <b-button
          id="copyPidButton"
          v-b-tooltip.click.top="$t('page.pid.toClipboard')"
          @click="copyPid"
        >
          <i-bi-clipboard />
        </b-button>
      </b-button-group>
    </CoscineFormGroup>

    <!-- Object Location -->
    <CoscineFormGroup
      v-if="digitalObjectLocation"
      label-for="ObjectLocation"
      :label="$t('page.pid.form.objectLocationLabel')"
    >
      <b-button-group class="w-100">
        <!-- Text Field -->
        <b-form-input
          id="ObjectLocation"
          v-model="digitalObjectLocation"
          :readonly="true"
          :disabled="true"
        />

        <!-- Open URL Button -->
        <b-button
          v-if="isPidUiUrlFound"
          id="openUrlButton"
          @click="openObjectLocation()"
        >
          <i-bi-link-45deg />
        </b-button>
        <!-- Copy Button -->
        <b-button
          v-else
          id="copyObjectLocation"
          v-b-tooltip.click.top="$t('page.pid.toLocation')"
          @click="copyUrl"
        >
          <i-bi-clipboard />
        </b-button>

        <!-- Open URL Tooltip -->
        <b-tooltip
          v-if="isPidUiUrlFound"
          id="openUrlTooltip"
          target="openUrlButton"
          placement="top"
          triggers="hover focus"
        >
          {{ $t("page.pid.openUrl") }}
        </b-tooltip>
      </b-button-group>
    </CoscineFormGroup>
    <div class="h-divider" />

    <!-- Contact PID Owner -->
    <CoscineHeadline :headline="$t('page.pid.contactPidOwnerTitle')" />

    <!-- Contact PID Owner Description -->
    <CoscineFormGroup>
      <b-form-text>{{ $t("page.pid.contactPidOwnerDescription") }}</b-form-text>
    </CoscineFormGroup>

    <!-- Your Name -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="YourName"
      :label="$t('page.pid.form.yourNameLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="YourName"
        v-model="v$.form.name.$model"
        :state="v$.form.name.$dirty ? !v$.form.name.$invalid : null"
        :placeholder="$t('page.pid.form.yourName')"
        :disabled="!pid || !isPidValid"
        required
      />
    </CoscineFormGroup>

    <!-- Your Email Address -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="YourEmail"
      :label="$t('page.pid.form.yourEmailAddressLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="YourEmail"
        v-model="v$.form.email.$model"
        :state="v$.form.email.$dirty ? !v$.form.email.$invalid : null"
        :placeholder="$t('page.pid.form.yourEmailAddress')"
        :disabled="!pid || !isPidValid"
        required
      />
    </CoscineFormGroup>

    <!-- Your Message -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="YourMessage"
      :label="$t('page.pid.form.yourMessageLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-textarea
        id="YourMessage"
        v-model="v$.form.message.$model"
        :state="v$.form.message.$dirty ? !v$.form.message.$invalid : null"
        :placeholder="$t('page.pid.form.yourMessage')"
        :disabled="!pid || !isPidValid"
        required
      />
    </CoscineFormGroup>

    <!-- Your Message -->
    <CoscineFormGroup :is-loading="isLoading" type="input">
      <b-form-checkbox
        v-model="v$.form.sendConfirmationEmail.$model"
        :disabled="!pid || !isPidValid"
      >
        {{ $t("page.pid.form.sendConfirmationEmail") }}
      </b-form-checkbox>
    </CoscineFormGroup>

    <b-form-group>
      <!-- Submit Button -->
      <b-button
        type="submit"
        variant="primary"
        class="float-end"
        :disabled="
          v$.form.$invalid || !v$.form.$anyDirty || isLoading || !isPidValid
        "
        @click.prevent="clickSubmit"
      >
        {{ $t("buttons.submit") }}
      </b-button>
    </b-form-group>
  </b-container>
</template>

<script lang="ts">
// import the store for current module
import usePidStore from "../store";
import useNotificationStore from "@/store/notification";
import { useVuelidate, type ValidationArgs } from "@vuelidate/core";
import { email, maxLength, required } from "@vuelidate/validators";
import type {
  HandleDto,
  PidRequestDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import { handleUrl, pidHandles } from "../utils/constants";
import useProjectStore from "@/modules/project/store";
import useResourceStore from "@/modules/resource/store";

export default defineComponent({
  setup() {
    const pidStore = usePidStore();
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();
    const notificationStore = useNotificationStore();

    const v$ = useVuelidate();

    return { pidStore, projectStore, resourceStore, notificationStore, v$ };
  },

  data() {
    return {
      form: {
        name: "",
        email: "",
        message: "",
        sendConfirmationEmail: true,
      } satisfies PidRequestDto,
      handle: undefined as HandleDto | undefined,
      digitalObjectLocation: undefined as string | undefined,
      isLoading: false,
      isPidValid: null as boolean | null,
      isPidUiUrlFound: false,
    };
  },

  computed: {
    pid(): string | null {
      const pid = this.$route.query["pid"];
      if (pid) {
        return pid.toString().replace(handleUrl, "");
      } else {
        return null;
      }
    },
    /**
     * A computed property that decodes the base64-encoded path from the URL hash.
     * If the hash is not specified, an empty string will be returned.
     * @returns {string} The decoded path from the URL hash.
     */
    path(): string {
      const hash = this.$route.hash;
      // Check for hash
      if (hash) {
        // Hash always starts with '#', trim it
        const parsedHash = new URLSearchParams(this.$route.hash.substring(1));
        // Url decode
        const path = decodeURI(parsedHash.get("path") ?? "");
        //Base64 decode
        return Buffer.from(path, "base64").toString();
      }
      return "";
    },
  },

  validations() {
    return {
      form: {
        name: { required },
        email: { email, required },
        message: { required, maxLength: maxLength(5000) },
        sendConfirmationEmail: { required },
      } satisfies ValidationArgs<PidRequestDto>,
    };
  },

  watch: {
    async pid() {
      await this.validatePid();
    },
    handle: {
      async handler() {
        // Try to build the UI URL from the PID, if it fails, use the digital object location from the handle
        this.digitalObjectLocation =
          (await this.buildUiUrlFromPid()) ??
          this.handle?.values?.find(
            (h) => h.type === pidHandles.digitalObjectLocation,
          )?.parsed_data;
      },
      deep: true,
    },
  },

  async created() {
    await this.validatePid();
  },

  methods: {
    copyPid() {
      if (this.pid) {
        navigator.clipboard.writeText(handleUrl + this.pid);
      }
    },
    copyUrl() {
      if (this.digitalObjectLocation) {
        navigator.clipboard.writeText(this.digitalObjectLocation);
      }
    },
    openObjectLocation() {
      if (this.digitalObjectLocation) {
        window.open(this.digitalObjectLocation, "_blank");
      }
    },
    /**
     * Asynchronously builds a UI URL based on the PID of the handle object.
     *
     * @method buildUiUrlFromPid
     * @async
     * @returns {Promise<string | undefined>} A promise that resolves to a string representing the UI URL, or undefined if the PID suffix is not found.
     *
     * The method works as follows:
     * 1. If the PID type is "project", it fetches the project by its ID and constructs a route to the project page.
     * 2. If the PID type is "resource", it fetches the resource by its ID and constructs a route to the resource page.
     * 3. If a route is found, it sets the `isPidUiUrlFound` flag to true.
     * 4. Finally, it returns the constructed URL, or undefined if no PID suffix was found.
     */
    async buildUiUrlFromPid(): Promise<string | undefined> {
      const id = this.handle?.pid?.suffix;
      if (!id) return;
      let route;
      let projectSlug;
      // Process type "project"
      if (this.handle?.pid?.type === "project") {
        const project = await this.projectStore.getProjectById(
          id,
          /*silent*/ true,
        );
        if (project && project.slug) {
          projectSlug = project.slug;
          route = this.$router.resolve({
            name: "project-page",
            params: { slug: projectSlug },
          });
        }
      }
      // Process type "resource"
      if (this.handle?.pid?.type === "resource") {
        const resource = await this.resourceStore.getResourceById(
          id,
          /*silent*/ true,
        );
        if (resource && resource.projects && resource.projects.length > 0) {
          projectSlug = resource.projects[0].id;
          route = this.$router.resolve({
            name: "resource-page",
            params: { slug: projectSlug!, guid: id, dirTrail: this.path },
          });
        }
      }
      if (route) {
        // We found a route
        this.isPidUiUrlFound = true;
        return `${window.location.origin}${route?.href}`;
      }
    },
    async validatePid() {
      this.isLoading = true;
      if (this.pid) {
        const prefix = this.pid.split("/").at(0);
        const id = this.pid.split("/").at(1);
        if (prefix && id) {
          this.isPidValid = await this.pidStore.validatePid(prefix, id);
          this.handle = await this.pidStore.getHandle(prefix, id);
        }
      }
      this.isLoading = false;
    },
    async clickSubmit() {
      if (this.pid && this.isPidValid && !this.v$.form.$invalid) {
        this.isLoading = true;
        const prefix = this.pid.split("/").at(0);
        const id = this.pid.split("/").at(1);
        if (prefix && id) {
          const success = await this.pidStore.contactPidOwner(
            prefix,
            id,
            this.form,
          );

          if (success) {
            // On Success
            this.notificationStore.postNotification({
              title: this.$t("page.pid.toastEmailSent.title").toString(),
              body: this.$t("page.pid.toastEmailSent.body").toString(),
            });
          }
        }
        // Clear the form
        this.form.name = "";
        this.form.email = "";
        this.form.message = "";
        this.v$.form.$reset();
        this.isLoading = false;
      }
    },
  },
});
</script>

<style scoped>
.pidContainer :deep(.row > *) {
  padding-left: 0;
}
</style>
